#include <cabocha.h>
#include <stdio.h>
#include <stdlib.h>

int main (int argc, char **argv)
{
   char p[] = "ϺϼϺäƤܤֻҤϤ";
   cabocha_t *c = cabocha_new (argc, argv);
   unsigned int i ;
   unsigned int size;
   unsigned int cid;
   char *result;
   cabocha_tree_t *tree;
   

   if (! c) {
      fprintf (stderr, "Exception: [%s]\n", cabocha_strerror (0));
      return -1;
   }

   result = cabocha_sparse_tostr (c, p);

   if (result == NULL) {
     fprintf (stderr, "Exception: [%s]\n", cabocha_strerror (c));
     return -1;
   }
   
   printf ("%s", result);

   tree = cabocha_sparse_totree (c, p);

   if (tree == NULL) {
     fprintf (stderr, "Exception: [%s]\n", cabocha_strerror (c));
     return -1;
   }
   

   printf ("%s", cabocha_tree_tostr (tree, 2));

   size = cabocha_tree_size (tree);

   cid = 0;
   for (i = 0; i < size; ++i) {
      cabocha_token_t *token = cabocha_tree_get_token (tree, i);
      if (token->chunk != NULL)
	 printf ("* %d %d%s %d/%d %f\n", cid++, 
		 token->chunk->link, 
		 token->chunk->rel, 
		 token->chunk->head,
		 token->chunk->func,
		 token->chunk->score);
      
      printf ("%s\t%s\t%s\t%s\t%s\t%s\t%s\n",
	      token->surface,
	      token->read, 
	      token->base,
	      token->pos,
	      token->ctype, 
	      token->cform,
	      token->ne);
   }
   printf ("EOS\n");

   cabocha_destroy (c);

   return 0;
}
 
