#include <cabocha.h>

// $Id: example2.cpp,v 1.5 2004/03/08 07:30:31 taku-ku Exp $;

// How to compile?
//  % c++ -O2 `cabocha-config --cflags` example2.cpp -o example2 `cabocha-config --libs`

int main (int argc, char **argv) 
{
  try {

    CaboCha::Parser parser (argc, argv);
     

    char p[] = "ϺϼϺäƤܤֻҤϤ";

    std::cout << parser.parseToString (p);
     
    CaboCha::Tree *tree = parser.parse (p);
     
    std::cout << tree->toString (2);

    unsigned int cid = 0;
    for (unsigned int i = 0; i < tree->size(); ++i) {
      CaboCha::Token *token = tree->getToken (i);

      // is this token begnning of chunk ?
      if (token->chunk) 
	std::cout << "* " 
		  <<  cid++ << ' '
		  << token->chunk->link
		  << token->chunk->rel  << ' '
		  << token->chunk->head  << '/'
		  << token->chunk->func  << ' '
		  << token->chunk->score << std::endl;

      std::cout << token->surface << '\t'
		<< token->read << '\t'
		<< token->base << '\t'
		<< token->pos << '\t'
		<< token->ctype << '\t'
		<< token->cform << '\t'
		<< token->ne << std::endl;
    }

    std::cout << "EOS\n";
  }

  catch (std::exception &e) {
    std::cerr << e.what () << std::endl;
    return -1;
  }
}
