/*
  CaboCha -- Yet Another Japanese Dependency Structure Analyzer

  $Id: chasenio.h,v 1.21 2005/12/24 12:30:35 taku Exp $;

  Copyright (C) 2000-2004 Taku Kudo <taku-ku@is.aist-nara.ac.jp>
  This is free software with ABSOLUTELY NO WARRANTY.

  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifndef _CABOCHA_CHASENIO_H
#define _CABOCHA_CHASENIO_H

#include "analyzer.h"
#include "common.h"
#include "cabocha.h"

#if (! defined CHASEN_USE_STATIC && defined HAVE_DLFCN_H) || (defined _WIN32 && ! defined (__CYGWIN__))
#include "DynamicLibrary.h"
#else
#ifndef CHASEN_USE_STATIC
#define CHASEN_USE_STATIC
#endif
#include <stdio.h>
extern "C" {
  int   chasen_getopt_argv  (char**, FILE*);
  char *chasen_sparse_tostr (char*);
}
#endif

namespace CaboCha
{

  struct ChaSenSingleton {
#ifndef CHASEN_USE_STATIC
    DynamicLibrary dl;
    DLPROC fpInit;
    DLPROC fpParse;
#endif
    std::string chasenrc;
  };

  class ChaSen: public Analyzer
  {
  private:
    static ChaSenSingleton *instance;

  public:
    bool open (Param &) ;
    Tree *parse (Tree *);

    ChaSen (Param &p) { if (!open(p)) throw std::runtime_error (_what); };
    ChaSen () {};
    ~ChaSen() {};
  };
}

#endif
