/*
  CaboCha -- Yet Another Japanese Dependency Structure Analyzer

  $Id: chunker.h,v 1.20 2005/12/24 12:30:35 taku Exp $;

  Copyright (C) 2000-2004 Taku Kudo <taku-ku@is.aist-nara.ac.jp>
  This is free software with ABSOLUTELY NO WARRANTY.

  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifndef _CABOCHA_CHUNKER_H_
#define _CABOCHA_CHUNKER_H_

#include "analyzer.h"
#include "cabocha.h"
#include <yamcha.h>

namespace CaboCha
{
  class Chunker: public Analyzer
  {
  private:
    yamcha_t *chunker;
    std::vector <const char*> feature;
    int partial_parsing;
    int action_mode;
    int ne;

  public:
    bool open (Param &);
    Tree *parse(Tree *);

    Chunker (Param &p): chunker(0), partial_parsing (0), action_mode(0), ne (0)
    { if (!open(p)) throw std::runtime_error (_what); };
    Chunker  (): chunker(0), partial_parsing (0), action_mode(0), ne(0) {};
    ~Chunker () { yamcha_destroy (chunker); };
  };
}
#endif
