/*
  CaboCha -- Yet Another Japanese Dependency Structure Analyzer

  $Id: mecabio.h,v 1.2 2005/12/24 12:30:35 taku Exp $;

  Copyright (C) 2000-2004 Taku Kudo <taku-ku@is.aist-nara.ac.jp>
  This is free software with ABSOLUTELY NO WARRANTY.

  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifndef _CABOCHA_MECABIO_H
#define _CABOCHA_MECABIO_H

#include "analyzer.h"
#include "common.h"
#include "cabocha.h"

#if (! defined MECAB_USE_STATIC && defined HAVE_DLFCN_H) || (defined _WIN32 && ! defined (__CYGWIN__))
#include "DynamicLibrary.h"
typedef struct _mecab_t *mecab_t;
#else
#ifndef MECAB_USE_STATIC
#define MECAB_USE_STATIC
#endif
#include <mecab.h>
#endif

namespace CaboCha
{
  class MeCab: public Analyzer
  {
  private:
    mecab_t *mecab;
#ifndef MECAB_USE_STATIC
    DynamicLibrary dl;
    DLPROC fpInit;
    DLPROC fpClose;
    DLPROC fpError;
    DLPROC fpParse;
#endif
    void close ();

  public:
    bool open (Param &) ;
    Tree *parse (Tree *);

    MeCab (Param &p): mecab(0) { if (!open(p)) throw std::runtime_error (_what); };
    MeCab (): mecab(0) {};
    ~MeCab () { close(); };
  };
}

#endif
