/*
  CaboCha -- Yet Another Japanese Dependency Structure Analyzer

  $Id: ne.h,v 1.6 2005/12/24 12:30:35 taku Exp $;

  Copyright (C) 2000-2004 Taku Kudo <taku-ku@is.aist-nara.ac.jp>
  This is free software with ABSOLUTELY NO WARRANTY.

  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifndef _CABOCHA_NE_H_
#define _CABOCHA_NE_H_

#include "analyzer.h"
#include "cabocha.h"
#include <yamcha.h>

#define NE_COMPOSIT "̾-"

namespace CaboCha
{
  class NE: public Analyzer
  {
  private:
    yamcha_t *chunker;
    std::vector <const char *> feature;
    int partial_parsing;
    int action_mode;
    char char_feature [32];

  public:
    bool open (Param &);
    Tree *parse(Tree *);

    NE (Param &p): chunker(0), partial_parsing(0), action_mode(0)
    {
      if (!open(p)) throw std::runtime_error (_what);
    };

    NE  (): chunker(0), partial_parsing (0), action_mode(0) {};
    ~NE () { yamcha_destroy(chunker); };
  };
}
#endif
